Texture2D tex0 <string uiname="Texture";>;
Texture3D texLUT <string uiname="Color LUT";>;
SamplerState s0 <bool visible=false;string uiname="Sampler";>
{Filter=MIN_MAG_MIP_LINEAR;AddressU=WRAP;AddressV=WRAP;};
SamplerState sL <bool visible=false;string uiname="LUT Sampler";>
{Filter=MIN_MAG_MIP_LINEAR;AddressU=CLAMP;AddressV=CLAMP;};
float4x4 tWVP:WORLDVIEWPROJECTION;
float4x4 tVP:VIEWPROJECTION;
float4x4 tW:WORLD;
float4x4 tV:VIEW;
float4x4 tP:PROJECTION;
float4x4 tWI:WORLDINVERSE;
float4x4 tVI:VIEWINVERSE;
float4x4 tPI:PROJECTIONINVERSE;
float4x4 tWIT:WORLDINVERSETRANSPOSE;

float Alpha <float uimin=0.0; float uimax=1.0;> = 1; 
float4 Color <bool color=true;> = {1.0,1.0,1.0,1.0};
float4x4 tTex <string uiname="Texture Transform";>;

struct VS_IN{
	float4 PosO:POSITION;
	float4 TexCd:TEXCOORD0;
};

struct VS_OUT{
	float4 PosWVP:SV_POSITION;
	float4 TexCd:TEXCOORD0;
};

VS_OUT VS(VS_IN In){
	VS_OUT Out=(VS_OUT)0;
	float4 PosW=In.PosO;
	PosW=mul(PosW,tW);
	Out.PosWVP=mul(PosW,tVP);
	Out.TexCd=mul(In.TexCd,tTex);
	return Out;
}

float4x4 tColIn <string uiname="Color Input Transform";>;
float4x4 tColOut <string uiname="Color Output Transform";>;
bool FitToVoxel=0;
float4 PS(VS_OUT In):SV_Target{
	float4 c=tex0.Sample(s0,In.TexCd.xy);
	
	c.rgb=mul(float4(c.rgb,1),tColIn).rgb;
	
	if(FitToVoxel){
		int3 vol;
		texLUT.GetDimensions(vol.x,vol.y,vol.z);
		c.rgb=c.rgb*(vol-1)/vol+0.5/vol;
	
	}
	float4 lutc=texLUT.SampleLevel(sL,c.rgb,0);
	c.rgb=lutc.rgb;
	c.rgb=mul(float4(c.rgb,1),tColOut).rgb;
	
	c=c*Color;
	c.a*=Alpha;
	return c;
}


technique10 Constant{
	pass P0{
		SetVertexShader(CompileShader(vs_5_0,VS()));
		SetPixelShader(CompileShader(ps_5_0,PS()));
	}
}




